/*
 * Copyright 2022 Peter <peter@quantr.hk>.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package hk.quantr.qemulogpanel;

import com.formdev.flatlaf.FlatLaf;
import com.formdev.flatlaf.intellijthemes.FlatArcOrangeIJTheme;
import hk.quantr.javalib.CommonLib;
import hk.quantr.javalib.PropertyUtil;
import static hk.quantr.qemulogpanel.QemuLogPanel.decimalFormatter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.File;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.TimeZone;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFrame;
import javax.swing.LookAndFeel;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import org.apache.commons.cli.CommandLine;
import org.apache.commons.cli.CommandLineParser;
import org.apache.commons.cli.DefaultParser;
import org.apache.commons.cli.HelpFormatter;
import org.apache.commons.cli.Option;
import org.apache.commons.cli.Options;
import org.apache.commons.cli.ParseException;
import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

/**
 *
 * @author Peter <peter@quantr.hk>
 */
public class MainFrame extends javax.swing.JFrame {

	private static final Logger logger = Logger.getLogger(MainFrame.class.getName());

	/**
	 * Creates new form MainFrame
	 */
	public MainFrame() {
		initComponents();
		addWindowListener(new WindowListener() {
			@Override
			public void windowOpened(WindowEvent e) {
			}

			@Override
			public void windowClosing(WindowEvent e) {
				Setting setting = Setting.getInstance();
				setting.x = getX();
				setting.y = getY();
				setting.width = getWidth();
				setting.height = getHeight();
				setting.dividerLocation = qemuLogPanel.jSplitPane1.getDividerLocation();
				setting.save();
			}

			@Override
			public void windowClosed(WindowEvent e) {
			}

			@Override
			public void windowIconified(WindowEvent e) {
			}

			@Override
			public void windowDeiconified(WindowEvent e) {
			}

			@Override
			public void windowActivated(WindowEvent e) {
			}

			@Override
			public void windowDeactivated(WindowEvent e) {
			}

		});
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
	 * Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        qemuLogPanel = new hk.quantr.qemulogpanel.QemuLogPanel();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        compareMenuItem = new javax.swing.JMenuItem();
        openQemuLogMenuItem = new javax.swing.JMenuItem();
        connectQemuH2MenuItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                formComponentShown(evt);
            }
        });
        getContentPane().setLayout(new java.awt.BorderLayout());
        getContentPane().add(qemuLogPanel, java.awt.BorderLayout.CENTER);

        jMenu1.setText("Tool");

        compareMenuItem.setText("Compare");
        compareMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                compareMenuItemActionPerformed(evt);
            }
        });
        jMenu1.add(compareMenuItem);

        openQemuLogMenuItem.setText("Open Qemu Log");
        openQemuLogMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openQemuLogMenuItemActionPerformed(evt);
            }
        });
        jMenu1.add(openQemuLogMenuItem);

        connectQemuH2MenuItem.setText("Connect Qemu H2");
        connectQemuH2MenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                connectQemuH2MenuItemActionPerformed(evt);
            }
        });
        jMenu1.add(connectQemuH2MenuItem);

        jMenuBar1.add(jMenu1);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void formComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentShown
		Setting setting = Setting.getInstance();
		qemuLogPanel.jSplitPane1.setDividerLocation(setting.dividerLocation == 0 ? 500 : setting.dividerLocation);
    }//GEN-LAST:event_formComponentShown

    private void compareMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_compareMenuItemActionPerformed
		qemuLogPanel.compareButton.doClick();
    }//GEN-LAST:event_compareMenuItemActionPerformed

    private void openQemuLogMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openQemuLogMenuItemActionPerformed
		qemuLogPanel.openButton.doClick();
    }//GEN-LAST:event_openQemuLogMenuItemActionPerformed

    private void connectQemuH2MenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_connectQemuH2MenuItemActionPerformed
		qemuLogPanel.connectQemuButton.doClick();
    }//GEN-LAST:event_connectQemuH2MenuItemActionPerformed

	public static void main(String args[]) throws UnsupportedLookAndFeelException, InstantiationException, IllegalAccessException, ParseException, Exception {
		Options options = new Options();
		options.addOption("v", "version", false, "display version");
		options.addOption("h", "help");
		options.addOption("g", "gui");
		options.addOption(Option.builder("f")
				.required(false)
				.hasArg()
				.argName("file")
				.desc("qemu log file")
				.build());
		options.addOption(Option.builder("i")
				.required(false)
				.build());
		options.addOption(Option.builder("d")
				.required(false)
				.hasArg()
				.argName("db")
				.desc("h2 database file")
				.build());
		options.addOption(Option.builder("j")
				.required(false)
				.hasArg()
				.argName("json")
				.desc("riscv-simulator dump.json")
				.build());
		options.addOption(Option.builder("2")
				.required(false)
				.hasArg()
				.argName("db")
				.desc("h2 database file")
				.longOpt("h2")
				.build());
		options.addOption(Option.builder("e")
				.required(false)
				.hasArg()
				.argName("xml")
				.desc("extract qemu interrupt sequence into quantr.xml")
				.longOpt("extract_interrupt")
				.build());
//		options.addOption(Option.builder("c")
//				.required(false)
//				.hasArg()
//				.argName("db,db")
//				.desc("compare two h2 db, pass the h2 db abs path without .mv.db")
//				.build());
		options.addOption("t", "use multithread");

		CommandLineParser parser = new DefaultParser();
		CommandLine cmd = parser.parse(options, args);

		if (cmd.hasOption("h")) {
			HelpFormatter formatter = new HelpFormatter();
			formatter.printHelp("java -jar qemu-log-panel.jar [OPTION]", options);
			return;
		}
		if (cmd.hasOption("i")) {
			Connection qemuConn = DriverManager.getConnection("jdbc:h2:./database", "sa", "");
			Statement statement = qemuConn.createStatement();
			ResultSet rs;
			int count;
			int maxSequence;
			try {
				rs = statement.executeQuery("select count(*) from `qemu`;");
				rs.next();
				count = rs.getInt("count(*)");
				System.out.println("qemu  : " + decimalFormatter.format(count));

				rs = statement.executeQuery("select max(sequence) from `qemu`;");
				rs.next();
				maxSequence = rs.getInt("max(sequence)");

				if (count != maxSequence + 1) {
					System.out.println("ERROR count!=max	, " + maxSequence);

					rs = statement.executeQuery("select count(*) from `qemu`;");
					rs.next();
					int lastSequence = rs.getInt("sequence");
					while (rs.next()) {
						if (rs.getInt("sequence") != lastSequence + 1) {
							System.out.println("lastSequence=" + lastSequence);
							System.exit(124);
						}
					}
				}
			} catch (Exception ex) {
				System.out.println("qemu  : 0");
			}
			try {
				rs = statement.executeQuery("select count(*) from `quantr`;");
				rs.next();
				System.out.println("quantr: " + decimalFormatter.format(rs.getInt("count(*)")));
			} catch (Exception ex) {
				System.out.println("quantr: 0");
			}
			return;
		}
		if (cmd.hasOption("v")) {
			System.out.println("version : " + PropertyUtil.getProperty("main.properties", "version"));

			TimeZone utc = TimeZone.getTimeZone("UTC");
			SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm");
			sdf.setTimeZone(utc);
			Calendar cl = Calendar.getInstance();
			try {
				Date convertedDate = sdf.parse(PropertyUtil.getProperty("main.properties", "build.date"));
				cl.setTime(convertedDate);
				cl.add(Calendar.HOUR, 8);
			} catch (java.text.ParseException ex) {
				logger.log(Level.SEVERE, null, ex);
			}
			System.out.println("build date : " + sdf.format(cl.getTime()) + " HKT");
			return;
		}
//		if (cmd.hasOption("c")) {
//			String db1 = cmd.getOptionValue("c").split(",")[0].trim();
//			String db2 = cmd.getOptionValue("c").split(",")[1].trim();
//			System.out.println(db1);
//			System.out.println(db2);
//			
//			return;
//		}
		if (cmd.hasOption("g")) {
			UIManager.setLookAndFeel(new FlatArcOrangeIJTheme());

			FlatLaf.setGlobalExtraDefaults(Collections.singletonMap("@accentColor", "#ff0000"));
			Class<? extends LookAndFeel> lafClass = UIManager.getLookAndFeel().getClass();
			FlatLaf.setup(lafClass.newInstance());
			FlatLaf.updateUI();

			MainFrame frame = new MainFrame();
			if (Setting.file.exists()) {
				Setting setting = Setting.getInstance();
				frame.setLocation(setting.x, setting.y);
				frame.setSize(setting.width, setting.height);
			} else {
				frame.setSize(1000, 800);
				frame.setLocationRelativeTo(null);
			}
			frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			frame.setTitle("Qemu Log");
			frame.setVisible(true);

			if (cmd.hasOption("f")) {
				try {
					File f = new File(cmd.getOptionValue("f").replaceFirst("^~", System.getProperty("user.home")));
					if (!f.exists()) {
						logger.log(Level.SEVERE, "{0} not exist", f.getAbsolutePath());
						System.exit(1);
					}
					if (cmd.hasOption("t")) {
						QemuLogPanel.convertQemuLogToH2(f, frame.qemuLogPanel.jProgressBar1, frame.qemuLogPanel.jTable1);
					}
				} catch (SQLException ex) {
					Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
				}
			}
			if (cmd.hasOption("d")) {
				File db = new File(cmd.getOptionValue("d").replaceFirst("^~", System.getProperty("user.home")));
				if (!db.exists()) {
					logger.log(Level.SEVERE, "{0} not exist", db.getAbsolutePath());
					System.exit(2);
				}

				frame.qemuLogPanel.pageNoTextField.setText(String.valueOf(Setting.getInstance().pageNo));
				QemuLogPanel.connect(db, frame.qemuLogPanel.jTable1, Setting.getInstance().pageNo);
				frame.qemuLogPanel.noOfRecordLabel.setText(decimalFormatter.format(((MyTableModel) frame.qemuLogPanel.jTable1.getModel()).qemuCount) + " records,");
				frame.qemuLogPanel.rowNoTextField.setText(String.valueOf(Setting.getInstance().rowNo));
				frame.qemuLogPanel.setRowNo();
			}
			if (cmd.hasOption("j")) {
				frame.qemuLogPanel.openDumpJson(new File(cmd.getOptionValue("j").replaceFirst("^~", System.getProperty("user.home"))));
			}
			if (cmd.hasOption("h2")) {
				frame.qemuLogPanel.openQuantrH2(new File(cmd.getOptionValue("h2").replaceFirst("^~", System.getProperty("user.home"))));
			}
		} else if (cmd.hasOption("e")) {
			try {
				DocumentBuilderFactory f = DocumentBuilderFactory.newInstance();
				DocumentBuilder b = f.newDocumentBuilder();
				File xml = new File(cmd.getOptionValue("e").replaceFirst("^~", System.getProperty("user.home")));
				Document doc = b.parse(xml);
				XPath xPath = XPathFactory.newInstance().newXPath();
				Node fireInterrupts = (Node) xPath.compile("//fireInterrupts").evaluate(doc, XPathConstants.NODE);
				fireInterrupts.setTextContent(null);
				Node memoryHiJacks = (Node) xPath.compile("//memoryHiJacks").evaluate(doc, XPathConstants.NODE);
				memoryHiJacks.setTextContent(null);

				// db
				Connection qemuConn = DriverManager.getConnection("jdbc:h2:./database", "sa", "");
				Statement qemuStmt = qemuConn.createStatement();

				// interrupt
				ResultSet qemuRS = qemuStmt.executeQuery("select ID-2 as ID, * from `qemu` where interrupt=true order by sequence");
				int x = 0;
				while (qemuRS.next()) {
					System.out.println((x++) + " interrupt = " + qemuRS.getInt("sequence"));

					Element fireInterruptElement = doc.createElement("FireInterrupt");

					Element element = doc.createElement("sequence");
					element.setTextContent(String.valueOf(qemuRS.getLong("sequence")));
					fireInterruptElement.appendChild(element);

					element = doc.createElement("cause");
					element.setTextContent(String.valueOf(qemuRS.getLong("interrupt_cause")));
					fireInterruptElement.appendChild(element);

					element = doc.createElement("desc");
					element.setTextContent(qemuRS.getString("interrupt_desc"));
					fireInterruptElement.appendChild(element);

					fireInterrupts.appendChild(fireInterruptElement);
				}
				// end interrupt

				// memoryHiJacks
				System.out.println("doing memoryHiJacks");
				qemuRS = qemuStmt.executeQuery("select * from `qemu` where memHiJack=true order by sequence");
				x = 0;
				while (qemuRS.next()) {
					Element memoryHiJackElement = doc.createElement("MemoryHiJack");

					Element element = doc.createElement("sequence");
					element.setTextContent(String.valueOf(qemuRS.getLong("sequence")));
					memoryHiJackElement.appendChild(element);

					element = doc.createElement("memRead");
					element.setTextContent(String.valueOf(qemuRS.getBoolean("memHiJackRead")));
					memoryHiJackElement.appendChild(element);

					element = doc.createElement("memAddr");
					element.setTextContent("0x" + Long.toHexString(qemuRS.getLong("memHiJackAddr")));
					memoryHiJackElement.appendChild(element);

					element = doc.createElement("memValue");
					element.setTextContent("0x" + Long.toHexString(qemuRS.getLong("memHiJackValue")));
					memoryHiJackElement.appendChild(element);

					element = doc.createElement("memSize");
					element.setTextContent(qemuRS.getString("memHiJackSize"));
					memoryHiJackElement.appendChild(element);

					System.out.println((x++) + " memoryHiJacks = " + qemuRS.getLong("sequence") + " > " + Long.toHexString(qemuRS.getLong("memHiJackAddr")) + " = " + Long.toHexString(qemuRS.getLong("memHiJackValue")) + "(" + qemuRS.getInt("memHiJackSize") + ")");

					memoryHiJacks.appendChild(memoryHiJackElement);
				}
				// end memoryHiJacks
				qemuConn.close();

				TransformerFactory transformerFactory = TransformerFactory.newInstance();
				Transformer tf = transformerFactory.newTransformer();
				tf.setOutputProperty(OutputKeys.INDENT, "yes");
				DOMSource domSource = new DOMSource(doc);
				StreamResult sr = new StreamResult(xml);
				tf.transform(domSource, sr);

				CommonLib.removeEmptyLines(xml);
				System.out.println("added records to " + xml.getAbsolutePath());
			} catch (IOException | SQLException | ParserConfigurationException | TransformerException | XPathExpressionException | DOMException | SAXException ex) {
				Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
			}
		} else if (cmd.hasOption("f")) {
			try {
				File f = new File(cmd.getOptionValue("f").replaceFirst("^~", System.getProperty("user.home")));
				if (!f.exists()) {
					logger.log(Level.SEVERE, "{0} not exist", f.getAbsolutePath());
					System.exit(1);
				}
				if (cmd.hasOption("t")) {
					QemuLogPanel.convertQemuLogToH2(f, null, null);
				}
			} catch (SQLException ex) {
				Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
			}
		}
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem compareMenuItem;
    private javax.swing.JMenuItem connectQemuH2MenuItem;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem openQemuLogMenuItem;
    public hk.quantr.qemulogpanel.QemuLogPanel qemuLogPanel;
    // End of variables declaration//GEN-END:variables

}
